#!/usr/bin/env node
// Generated by LiveScript 1.6.0
var fs, os, unified, remarkParse, async, colorette, yargs, saxParser, exec, ref$, each, map, fold, unwords, keys, first, concat, dmp, homepageLink, exitCode, argv, formatPosition, indent, formatProperties, successText, failureText, parsingError, runTests, die, extractHtmlComments, unescape, testThis, files, x$, toString$ = {}.toString;
fs = require('fs');
os = require('os');
unified = require('unified');
remarkParse = require('remark-parse');
async = require('async');
colorette = require('colorette');
yargs = require('yargs');
saxParser = require('parse5-sax-parser');
exec = require('child_process').exec;
ref$ = require('prelude-ls'), each = ref$.each, map = ref$.map, fold = ref$.fold, unwords = ref$.unwords, keys = ref$.keys, first = ref$.first;
concat = require('concat-stream');
dmp = new (require('diff-match-patch'))();
homepageLink = require('./package.json').homepage;
exitCode = {
  SUCCESS: 0,
  TEST_FAILURE: 1,
  FORMAT_ERROR: 2,
  INTERNAL_ERROR: 3
};
argv = function(){
  var argvToParse, that;
  argvToParse = (that = process.argv.lsc) != null
    ? that.slice(1)
    : process.argv.slice(2);
  return yargs.option('jobs', {
    desc: "How many tests may run in parallel",
    'default': os.cpus().length,
    defaultDescription: "# of CPU cores",
    nargs: 1
  }).check(function(args){
    if (args.jobs != null) {
      if (!(typeof args.jobs === 'number' && Number.isInteger(args.jobs) && args.jobs >= 1)) {
        throw Error("Invalid --jobs value '" + args.jobs + "' (expected integer >= 1)");
      }
    }
    return true;
  }).help().parse(argvToParse);
}();
formatPosition = function(position){
  var pos;
  pos = {
    start: position.start.line,
    end: position.end.line
  };
  if (pos.start === pos.end) {
    return "line " + pos.start;
  } else {
    return "lines " + pos.start + "-" + pos.end;
  }
};
indent = function(n, text){
  var spaces, lines;
  spaces = repeatString$("  ", n);
  lines = text.split(os.EOL).map(function(it){
    if (it.length) {
      return spaces + it;
    } else {
      return it;
    }
  });
  return lines.join(os.EOL);
};
formatProperties = function(properties, indentLevel){
  var text, key, value, i$, len$, v;
  indentLevel == null && (indentLevel = 0);
  text = indent(indentLevel, colorette.dim("---") + "");
  for (key in properties) {
    value = properties[key];
    text += "\n" + indent(indentLevel, colorette.blue(key) + ":");
    switch (toString$.call(value).slice(8, -1)) {
    case 'Array':
      for (i$ = 0, len$ = value.length; i$ < len$; ++i$) {
        v = value[i$];
        text += "\n" + indent(indentLevel + 1, "- " + v.toString());
      }
      break;
    case 'Number':
      text += " " + value.toString();
      break;
    case 'String':
      if (deepEq$(value, "", '===')) {
        text += " ''";
      } else {
        text += " |\n" + indent(indentLevel + 1, value);
      }
      break;
    default:
      text += "\n" + indent(indentLevel + 1, value.toString());
    }
  }
  text += "\n" + indent(indentLevel, colorette.dim("---") + "");
  return text;
};
successText = function(index, name){
  return colorette.green("ok") + " " + colorette.dim(index) + " " + name;
};
failureText = function(index, name, failureReason, properties){
  var text;
  text = colorette.red("not ok") + " " + colorette.dim(index);
  text += " " + name + colorette.dim(": " + failureReason);
  if (properties) {
    text += "\n" + formatProperties(properties, 1);
  }
  return text;
};
parsingError = function(name, failureReason, properties){
  console.log(colorette.dim("0..0"));
  console.log(failureText(0, name, failureReason, properties));
  console.log();
  console.log(colorette.black(
  colorette.bgRed(
  "# FAILED TO PARSE TESTS")));
  return process.exit(exitCode.FORMAT_ERROR);
};
runTests = function(queue){
  var printsWaiting, nextIndexToPrint, successes, failures, tryToSay, succeed, fail, e;
  try {
    if (queue.length === 0) {
      console.log(colorette.yellow("1..0"));
      console.log(colorette.yellow("# no tests"));
      console.log(colorette.dim("# For help, see " + homepageLink));
      process.exit(exitCode.SUCCESS);
    }
    console.log(colorette.dim("1.." + queue.length));
    printsWaiting = [];
    nextIndexToPrint = 0;
    successes = 0;
    failures = 0;
    tryToSay = function(index, text){
      var that;
      if (index === nextIndexToPrint) {
        console.log(text);
        ++nextIndexToPrint;
        if (that = printsWaiting[nextIndexToPrint]) {
          return tryToSay(nextIndexToPrint, that);
        }
      } else {
        return printsWaiting[index] = text;
      }
    };
    succeed = function(index, name, properties){
      ++successes;
      return tryToSay(index, successText(index + 1, name));
    };
    fail = function(index, name, failureReason, properties){
      var text;
      ++failures;
      text = failureText(index + 1, name, failureReason, properties);
      return tryToSay(index, text);
    };
    return async.eachOfLimit(queue, argv.jobs, function(test, index, cb){
      var validInput, validOutput, validError, validCheck, validProgram, earlierPosition, debugProperties, earliestPosition, that, noStdout, ref$, noStderr, ref1$, ref2$, ref3$, ref4$, normaliseTest, withLocationProps, makeColouredDiff, resultCallback, x$;
      validInput = function(test){
        var ref$;
        if (((ref$ = test.input) != null ? ref$.length : void 8) === 1) {
          return test.input[0];
        } else {
          return false;
        }
      };
      validOutput = function(test){
        var ref$;
        if (((ref$ = test.output) != null ? ref$.length : void 8) === 1) {
          return test.output[0];
        } else {
          return false;
        }
      };
      validError = function(test){
        var ref$;
        if (((ref$ = test.error) != null ? ref$.length : void 8) === 1) {
          return test.error[0];
        } else {
          return false;
        }
      };
      validCheck = function(test){
        var ref$;
        if (((ref$ = test.check) != null ? ref$.length : void 8) === 1) {
          return test.check[0];
        } else {
          return false;
        }
      };
      validProgram = function(test){
        var nonNullPrograms, ref$;
        nonNullPrograms = test.program.filter(function(it){
          return it != null;
        });
        return (ref$ = test.program)[ref$.length - 1] || false;
      };
      earlierPosition = function(a, b){
        if (!a) {
          return b;
        }
        if (!b) {
          return a;
        }
        if (a.start.offset < b.start.offset) {
          return a;
        } else {
          return b;
        }
      };
      if (!validProgram(test)) {
        debugProperties = {};
        earliestPosition = null;
        if (that = validInput(test)) {
          debugProperties["input location"] = formatPosition(that.position);
          earliestPosition = earlierPosition(that.position, earliestPosition);
        }
        if (that = validOutput(test)) {
          debugProperties["output location"] = formatPosition(that.position);
          earliestPosition = earlierPosition(that.position, earliestPosition);
        }
        debugProperties["how to fix"] = "Declare a test program before " + formatPosition(earliestPosition) + ",\nusing <!-- !test program <TEST PROGRAM HERE> -->";
        fail(index, test.name, "no program defined", debugProperties);
        cb();
        return;
      }
      if (test.check) {
        if (test.input) {
          fail(index, test.name, "defined as check, but also has input", {
            "input locations": test.input.map(function(it){
              return formatPosition(it.position);
            }),
            "how to fix": "Remove the input, or create an in/out test instead."
          });
          cb();
          return;
        }
        if (test.output) {
          fail(index, test.name, "defined as check, but also has output", {
            "output locations": test.output.map(function(it){
              return formatPosition(it.position);
            }),
            "how to fix": "Remove the output, or create an in/out test instead."
          });
          cb();
          return;
        }
        if (test.error) {
          fail(index, test.name, "defined as check, but also has error", {
            "error locations": test.error.map(function(it){
              return formatPosition(it.position);
            }),
            "how to fix": "Remove the error, or create an in/out test instead."
          });
          cb();
          return;
        }
        if (test.check.length > 1) {
          fail(index, test.name, "multiple checks defined", {
            "check locations": test.check.map(function(it){
              return formatPosition(it.position);
            }),
            "how to fix": "Remove or rename the other checks."
          });
          cb();
          return;
        }
      } else {
        if (test.input == null || test.input.length === 0) {
          debugProperties = {};
          if (that = validOutput(test)) {
            debugProperties["output location"] = formatPosition(that.position);
          }
          debugProperties["how to fix"] = "Define an input for '" + test.name + "', using\n\n  <!-- !test in " + test.name + " -->\n\nfollowed by a code block.";
          fail(index, test.name, "input not defined", debugProperties);
          cb();
          return;
        }
        noStdout = test.output == null || ((ref$ = test.output) != null ? ref$.length : void 8) === 0;
        noStderr = test.error == null || ((ref1$ = test.error) != null ? ref1$.length : void 8) === 0;
        if (noStdout && noStderr) {
          debugProperties = {};
          if (that = validInput(test)) {
            debugProperties["input location"] = formatPosition(that.position);
          }
          debugProperties["how to fix"] = "Define an output or error for '" + test.name + "', using\n\n  <!-- !test out " + test.name + " -->\n\nor\n\n  <!-- !test err " + test.name + " -->\n\nfollowed by a code block.";
          fail(index, test.name, "only input defined", debugProperties);
          cb();
          return;
        }
        if (((ref2$ = test.input) != null ? ref2$.length : void 8) > 1) {
          debugProperties = {};
          if (that = validOutput(test)) {
            debugProperties["output location"] = formatPosition(that.position);
          }
          debugProperties["input locations"] = test.input.map(function(it){
            return formatPosition(it.position);
          });
          debugProperties["how to fix"] = "Remove or rename the other inputs.";
          fail(index, test.name, "multiple inputs defined", debugProperties);
          cb();
          return;
        }
        if (((ref3$ = test.output) != null ? ref3$.length : void 8) > 1) {
          debugProperties = {};
          if (that = validInput(test)) {
            debugProperties["input location"] = formatPosition(that.position);
          }
          debugProperties["output locations"] = test.output.map(function(it){
            return formatPosition(it.position);
          });
          debugProperties["how to fix"] = "Remove or rename the other outputs.";
          fail(index, test.name, "multiple outputs defined", debugProperties);
          cb();
          return;
        }
        if (((ref4$ = test.error) != null ? ref4$.length : void 8) > 1) {
          debugProperties = {};
          if (that = validInput(test)) {
            debugProperties["input location"] = formatPosition(that.position);
          }
          debugProperties["error locations"] = test.error.map(function(it){
            return formatPosition(it.position);
          });
          debugProperties["how to fix"] = "Remove or rename the other errors.";
          fail(index, test.name, "multiple errors defined", debugProperties);
          cb();
          return;
        }
      }
      normaliseTest = function(t){
        var normalised, that;
        normalised = {
          name: t.name,
          program: validProgram(t)
        };
        if (that = validInput(test)) {
          normalised.input = that;
        }
        if (that = validOutput(test)) {
          normalised.output = that;
        }
        if (that = validError(test)) {
          normalised.error = that;
        }
        if (that = validCheck(test)) {
          normalised.check = that;
        }
        return normalised;
      };
      test = normaliseTest(test);
      withLocationProps = function(obj){
        var x$, locationProps, y$, props;
        x$ = locationProps = {};
        if (test.check != null) {
          x$["check location"] = formatPosition(test.check.position);
        }
        if (test.input != null) {
          x$["input location"] = formatPosition(test.input.position);
        }
        if (test.output != null) {
          x$["output location"] = formatPosition(test.output.position);
        }
        if (test.error != null) {
          x$["error location"] = formatPosition(test.error.position);
        }
        y$ = props = {};
        Object.assign(y$, obj);
        Object.assign(y$, locationProps);
        return y$;
      };
      makeColouredDiff = function(expected, actual){
        var diff, withVisibleNewlines, expectedWithHighlights, actualWithHighlights;
        if (!process.stdout.isTTY) {
          return {
            expected: expected,
            actual: actual
          };
        } else {
          diff = dmp.diff_main(expected, actual);
          dmp.diff_cleanupSemantic(diff);
          withVisibleNewlines = function(it){
            return it.replace(new RegExp(os.EOL, 'g'), function(x){
              return "↵" + x;
            });
          };
          expectedWithHighlights = diff.reduce(function(previous, arg$){
            var change, text;
            change = arg$[0], text = arg$[1];
            switch (change) {
            case 0:
              return previous + text;
            case -1:
              text = withVisibleNewlines(text);
              return previous + colorette.strikethrough(
              colorette.inverse(
              colorette.red(
              text)));
            default:
              return previous;
            }
          }, "");
          actualWithHighlights = diff.reduce(function(previous, arg$){
            var change, text;
            change = arg$[0], text = arg$[1];
            switch (change) {
            case 0:
              return previous + text;
            case 1:
              text = withVisibleNewlines(text);
              return previous + colorette.inverse(
              colorette.green(
              text));
            default:
              return previous;
            }
          }, "");
          return {
            expected: expectedWithHighlights,
            actual: actualWithHighlights
          };
        }
      };
      resultCallback = function(e, stdout, stderr){
        var ref$, expected, actual;
        if (e) {
          fail(index, test.name, "program exited with error", withLocationProps({
            program: test.program.code,
            "exit status": e.code,
            stderr: stderr,
            stdout: stdout
          }));
          cb();
          return;
        } else {
          if (test.check) {
            succeed(index, test.name);
            cb();
            return;
          }
          if (test.output != null && stdout !== test.output.text) {
            ref$ = makeColouredDiff(test.output.text, stdout), expected = ref$.expected, actual = ref$.actual;
            fail(index, test.name, "output mismatch", withLocationProps({
              "expected stdout": expected,
              "actual stdout": actual,
              program: test.program.code
            }));
            cb();
            return;
          }
          if (test.error != null && stderr !== test.error.text) {
            ref$ = makeColouredDiff(test.error.text, stderr), expected = ref$.expected, actual = ref$.actual;
            fail(index, test.name, "error mismatch", withLocationProps({
              "expected stderr": expected,
              "actual stderr": actual,
              program: test.program.code
            }));
            cb();
            return;
          }
          succeed(index, test.name);
          cb();
          return;
        }
        return cb();
      };
      x$ = exec(test.program.code, resultCallback);
      x$.stdin.on('error', function(it){
        if (it.code === 'EPIPE') {} else {
          throw it;
        }
      });
      if (test.input) {
        x$.stdin.end(test.input.text);
      } else {
        x$.stdin.end(test.check.text);
      }
      return x$;
    }, function(e){
      var colour, colourInverse;
      if (e) {
        die(e.message);
      }
      console.log();
      colour = failures === 0
        ? colorette.green
        : colorette.red;
      colourInverse = compose$(colorette.inverse, colour);
      console.log(colour("# " + successes + "/" + queue.length + " passed"));
      if (failures === 0) {
        return console.log(colourInverse("# OK"));
      } else {
        console.log(colourInverse("# FAILED " + failures));
        return process.exit(exitCode.TEST_FAILURE);
      }
    });
  } catch (e$) {
    e = e$;
    return die(e);
  }
};
die = function(message){
  console.error(message);
  return process.exit(exitCode.INTERNAL_ERROR);
};
extractHtmlComments = function(input){
  var comments, x$, p;
  comments = [];
  x$ = p = new saxParser();
  x$.on('comment', function(it){
    return comments.push(it.text);
  });
  x$.end(input);
  return comments;
};
/*
  Consecutive dashes ("--") are illegal inside HTML comments, so let's allow
  them to be escaped with the sequence "\-".  We treat "\-" like a single token
  that can be escaped ("\\-") to get a literal "\-".  This way, users can still
  write "\" in other contexts (which is common in shell scripts for the
  "program" command) without entering backslash hell.
*/
unescape = function(it){
  return it.replace(/#-/g, '-');
};
testThis = function(contents){
  var testSpecs, addToTestSpec, howToFixUnexpectedCommandExplanation, stateMachine, visit, mdastSyntaxTree, tests, name, properties, test, k, v;
  console.log("TAP version 13");
  /*
    A test spec is a set of program, input, and expected output.  We maintain a
    collection of the incomplete ones indexed by name (unique identifier
    decided by the user).  Whenever new information is available for the test
    spec corresponding to a name, we add that information, and when it's
    complete, delete it from the incomplete list and queue it for running.
  */
  testSpecs = {};
  addToTestSpec = function(name, key, value){
    var testSpec;
    testSpec = name in testSpecs
      ? testSpecs[name]
      : {};
    testSpecs[name] = testSpec;
    (testSpec[key] || (testSpec[key] = [])).push(value);
  };
  howToFixUnexpectedCommandExplanation = "Check that your 'in' / 'out' / 'err' / 'check' commands are each followed\nby a block of code, not another test command.";
  /*
    This state machine describes the state that the parser is in.  The 'now'
    property holds its current state.  States are represented by constructor
    functions take parameters, through which data is passed when transitioning
    between states.
  
    Each state can react to texts (i.e. code blocks) or commands (i.e. HTML
    comments containing "!test" commands) in whatever way is appropriate for
    that state.
  */
  stateMachine = {
    waitingForProgramText: function(){
      return {
        gotText: function(){},
        gotCommand: function(name, text, position){
          switch (name) {
          case 'program':
            stateMachine.now = stateMachine.waitingForAnyCommand({
              program: {
                code: text,
                position: position
              }
            });
          }
        }
      };
    },
    waitingForAnyCommand: function(arg$){
      var program;
      program = arg$.program;
      return {
        gotText: function(){},
        gotCommand: function(name, text, position){
          switch (name) {
          case 'program':
            stateMachine.now = stateMachine.waitingForAnyCommand({
              program: {
                code: text,
                position: position
              }
            });
            break;
          case 'in':
            stateMachine.now = stateMachine.waitingForInputText({
              program: program,
              name: text
            });
            break;
          case 'out':
            stateMachine.now = stateMachine.waitingForOutputText({
              program: program,
              name: text
            });
            break;
          case 'err':
            stateMachine.now = stateMachine.waitingForErrorText({
              program: program,
              name: text
            });
            break;
          case 'check':
            stateMachine.now = stateMachine.waitingForCheckText({
              program: program,
              name: text
            });
          }
        }
      };
    },
    waitingForInputText: function(arg$){
      var program, name;
      program = arg$.program, name = arg$.name;
      return {
        gotText: function(text, position){
          stateMachine.now = stateMachine.waitingForAnyCommand({
            program: program
          });
          addToTestSpec(name, 'input', {
            text: text,
            position: position
          });
          addToTestSpec(name, 'program', program);
        },
        gotCommand: function(name, text, position){
          parsingError("'" + name + " " + text + "'", "unexpected command (expected input text)", {
            location: formatPosition(position),
            "how to fix": howToFixUnexpectedCommandExplanation
          });
        }
      };
    },
    waitingForOutputText: function(arg$){
      var program, name;
      program = arg$.program, name = arg$.name;
      return {
        gotText: function(text, position){
          stateMachine.now = stateMachine.waitingForAnyCommand({
            program: program
          });
          addToTestSpec(name, 'output', {
            text: text,
            position: position
          });
          addToTestSpec(name, 'program', program);
        },
        gotCommand: function(name, text, position){
          parsingError("'" + name + " " + text + "'", "unexpected command (expected output text)", {
            location: formatPosition(position),
            "how to fix": howToFixUnexpectedCommandExplanation
          });
        }
      };
    },
    waitingForErrorText: function(arg$){
      var program, name;
      program = arg$.program, name = arg$.name;
      return {
        gotText: function(text, position){
          stateMachine.now = stateMachine.waitingForAnyCommand({
            program: program
          });
          addToTestSpec(name, 'error', {
            text: text,
            position: position
          });
          addToTestSpec(name, 'program', program);
        },
        gotCommand: function(name, text, position){
          parsingError("'" + name + " " + text + "'", "unexpected command (expected error text)", {
            location: formatPosition(position),
            "how to fix": howToFixUnexpectedCommandExplanation
          });
        }
      };
    },
    waitingForCheckText: function(arg$){
      var program, name;
      program = arg$.program, name = arg$.name;
      return {
        gotText: function(text, position){
          stateMachine.now = stateMachine.waitingForAnyCommand({
            program: program
          });
          addToTestSpec(name, 'check', {
            text: text,
            position: position
          });
          addToTestSpec(name, 'program', program);
        },
        gotCommand: function(name, text, position){
          parsingError("'" + name + " " + text + "'", "unexpected command (expected check input text)", {
            location: formatPosition(position),
            "how to fix": howToFixUnexpectedCommandExplanation
          });
        }
      };
    }
  };
  stateMachine.now = stateMachine.waitingForAnyCommand({
    program: null
  });
  visit = function(node){
    var textContent;
    if (node.type === 'html') {
      return extractHtmlComments(node.value).forEach(function(comment){
        var re, ref$, _, command, commandWords, firstWord, supportedCommands, rest;
        re = /(?:\s+)?!test\s+([\s\S]*)/m;
        ref$ = comment.trim().match(re) || [], _ = ref$[0], command = ref$[1];
        if (command) {
          commandWords = command.split(/\s+/);
          firstWord = first(commandWords);
          supportedCommands = ['program', 'in', 'out', 'err', 'check'];
          if (in$(firstWord, supportedCommands)) {
            rest = unescape(
            function(it){
              return it.trim();
            }(
            function(it){
              return it.slice(firstWord.length);
            }(
            command)));
            return stateMachine.now.gotCommand(firstWord, rest, node.position);
          } else {
            return parsingError("'" + firstWord + "'", "unknown command type", {
              location: formatPosition(node.position),
              "supported commands": supportedCommands
            });
          }
        }
      });
    } else if (node.type === 'code') {
      textContent = node.value + os.EOL;
      return stateMachine.now.gotText(textContent, node.position);
    } else if ('children' in node) {
      return each(visit)(
      node.children);
    }
  };
  mdastSyntaxTree = unified().use(remarkParse).parse(contents);
  visit(mdastSyntaxTree);
  tests = [];
  for (name in testSpecs) {
    properties = testSpecs[name];
    test = {
      name: name
    };
    for (k in properties) {
      v = properties[k];
      test[k] = v;
    }
    tests.push(test);
  }
  return runTests(tests);
};
files = argv._;
if (files.length === 0) {
  x$ = process.stdin;
  x$.on('error', function(e){
    return die(e.message);
  });
  x$.pipe(concat(function(data){
    return testThis(data);
  }));
} else {
  each(function(file){
    return fs.readFile(file, function(e, data){
      if (e) {
        throw e;
      }
      return testThis(data);
    });
  })(
  files);
}
function repeatString$(str, n){
  for (var r = ''; n > 0; (n >>= 1) && (str += str)) if (n & 1) r += str;
  return r;
}
function deepEq$(x, y, type){
  var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
      has = function (obj, key) { return hasOwnProperty.call(obj, key); };
  var first = true;
  return eq(x, y, []);
  function eq(a, b, stack) {
    var className, length, size, result, alength, blength, r, key, ref, sizeB;
    if (a == null || b == null) { return a === b; }
    if (a.__placeholder__ || b.__placeholder__) { return true; }
    if (a === b) { return a !== 0 || 1 / a == 1 / b; }
    className = toString.call(a);
    if (toString.call(b) != className) { return false; }
    switch (className) {
      case '[object String]': return a == String(b);
      case '[object Number]':
        return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
      case '[object Date]':
      case '[object Boolean]':
        return +a == +b;
      case '[object RegExp]':
        return a.source == b.source &&
               a.global == b.global &&
               a.multiline == b.multiline &&
               a.ignoreCase == b.ignoreCase;
    }
    if (typeof a != 'object' || typeof b != 'object') { return false; }
    length = stack.length;
    while (length--) { if (stack[length] == a) { return true; } }
    stack.push(a);
    size = 0;
    result = true;
    if (className == '[object Array]') {
      alength = a.length;
      blength = b.length;
      if (first) {
        switch (type) {
        case '===': result = alength === blength; break;
        case '<==': result = alength <= blength; break;
        case '<<=': result = alength < blength; break;
        }
        size = alength;
        first = false;
      } else {
        result = alength === blength;
        size = alength;
      }
      if (result) {
        while (size--) {
          if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
        }
      }
    } else {
      if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
        return false;
      }
      for (key in a) {
        if (has(a, key)) {
          size++;
          if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
        }
      }
      if (result) {
        sizeB = 0;
        for (key in b) {
          if (has(b, key)) { ++sizeB; }
        }
        if (first) {
          if (type === '<<=') {
            result = size < sizeB;
          } else if (type === '<==') {
            result = size <= sizeB
          } else {
            result = size === sizeB;
          }
        } else {
          first = false;
          result = size === sizeB;
        }
      }
    }
    stack.pop();
    return result;
  }
}
function compose$() {
  var functions = arguments;
  return function() {
    var i, result;
    result = functions[0].apply(this, arguments);
    for (i = 1; i < functions.length; ++i) {
      result = functions[i](result);
    }
    return result;
  };
}
function in$(x, xs){
  var i = -1, l = xs.length >>> 0;
  while (++i < l) if (x === xs[i]) return true;
  return false;
}
